Loading...
Searching...
No Matches
CFunctionSRet< SignatureT > Struct Template Reference

Represents a concrete C function binding with the first argument as its return type. More...

`#include <openvdb_ax/codegen/FunctionTypes.h>`

Inheritance diagram for CFunctionSRet< SignatureT >:

## Public Types

using | BaseT = SRetFunction<SignatureT, CFunction<SignatureT>>
using | Ptr
using | Traits
using | CFunctionT = CFunction<SignatureT>
enum | SignatureMatch { None = 0 , Size , Implicit , Explicit }
| The result type from calls to Function::match. More...

## Public Member Functions

| CFunctionSRet (const std::string &symbol, const SignatureT function)
| ~CFunctionSRet () override=default
Function::SignatureMatch | match (const std::vector< llvm::Type * > &args, llvm::LLVMContext &C) const override
| Override of match which inserts the SRET type such that the base class methods ignore it.
llvm::Value * | call (const std::vector< llvm::Value * > &args, llvm::IRBuilder<> &B, const bool cast) const override
| Override of call which allocates the required SRET llvm::Value for this function.
void | print (llvm::LLVMContext &C, std::ostream &os, const char *name=nullptr, const bool axTypes=true) const override
| Override of print to avoid printing out the SRET type.
llvm::Type * | types (std::vector< llvm::Type * > &types, llvm::LLVMContext &C) const override
| Populate a vector of llvm::Types which describe this function signature. This method is used by Function::create, Function::print and Function::match.
uint64_t | address () const override final
| Returns the global address of this function.
llvm::Value * | fold (const std::vector< llvm::Value * > &args, llvm::LLVMContext &C) const override final
void | setConstantFold (bool on)
bool | hasConstantFold () const
virtual llvm::Function * | create (llvm::LLVMContext &C, llvm::Module *M=nullptr) const
| Converts and creates this AX function into a llvm Function.
llvm::Function * | create (llvm::Module &M) const
| Convenience method which always uses the provided module to find the function or insert it if necessary.
llvm::Function * | get (const llvm::Module &M) const
| Convenience method for calling M.getFunction(symbol). Returns a nullptr if the function has not yet been created or if it is embedded IR.
size_t | size () const
| The number of arguments that this function has.
const char * | symbol () const
| The function symbol name.
const char * | argName (const size_t idx) const
| Returns the descriptive name of the given argument index.
bool | hasParamAttribute (const size_t i, const llvm::Attribute::AttrKind &kind) const
| Builder methods.
void | setArgumentNames (std::vector< const char * > names)
const std::vector< const char * > & | dependencies () const
void | setDependencies (std::vector< const char * > deps)
void | setFnAttributes (const std::vector< llvm::Attribute::AttrKind > &in)
void | setRetAttributes (const std::vector< llvm::Attribute::AttrKind > &in)
void | setParamAttributes (const size_t i, const std::vector< llvm::Attribute::AttrKind > &in)

## Static Protected Member Functions

static void | cast (std::vector< llvm::Value * > &args, const std::vector< llvm::Type * > &types, llvm::IRBuilder<> &B)
| Cast the provided arguments to the given type as supported by implicit casting of function types. If the types already match OR if a cast cannot be performed, nothing is done to the argument.

## Detailed Description

template<typename SignatureT>
struct openvdb::v10_0::ax::codegen::CFunctionSRet< SignatureT >

Represents a concrete C function binding with the first argument as its return type.

## Member Typedef Documentation

## BaseT

template<typename SignatureT>

using BaseT = SRetFunction<SignatureT, CFunction<SignatureT>>

## CFunctionT

template<typename SignatureT>

using CFunctionT = CFunction<SignatureT>

inherited

## Ptr

using Ptr

inherited

## Traits

using Traits

inherited

## Member Enumeration Documentation

## SignatureMatch

enum SignatureMatch

inherited

The result type from calls to Function::match.

Enumerator
None |
Size |
Implicit |
Explicit |

## Constructor & Destructor Documentation

## CFunctionSRet()

template<typename SignatureT>

CFunctionSRet | ( | const std::string & | symbol,
|  | const SignatureT | function )

inline

## ~CFunctionSRet()

template<typename SignatureT>

~CFunctionSRet | ( |  | ) |

override default

## Member Function Documentation

## address()

template<typename SignatureT>

uint64_t address | ( |  | ) | const

inline final override virtual inherited

Returns the global address of this function.

Note
  This is only required for C bindings.

Implements CFunctionBase.

## argName()

const char * argName | ( | const size_t | idx | ) | const

inline inherited

Returns the descriptive name of the given argument index.

If the index is greater than the number of arguments, an empty string is returned.

Parameters

  idx | The index of the argument

## call()

llvm::Value * call | ( | const std::vector< llvm::Value * > & | args,
|  | llvm::IRBuilder<> & | B,
|  | const bool | cast ) const

inline override virtual inherited

Override of call which allocates the required SRET llvm::Value for this function.

Note
  Unlike other function where the returned llvm::Value* is a llvm::CallInst (which also represents the return value), SRET functions return the allocated 1st argument i.e. not a llvm::CallInst

Reimplemented from CFunction< SignatureT >.

## cast()

void cast | ( | std::vector< llvm::Value * > & | args,
|  | const std::vector< llvm::Type * > & | types,
|  | llvm::IRBuilder<> & | B )

static protected inherited

Cast the provided arguments to the given type as supported by implicit casting of function types. If the types already match OR if a cast cannot be performed, nothing is done to the argument.

## create() [1/2]

virtual llvm::Function * create | ( | llvm::LLVMContext & | C,
|  | llvm::Module * | M = nullptr ) const

virtual inherited

Converts and creates this AX function into a llvm Function.

This method uses the result from Function::types() to construct a llvm::FunctionType and a subsequent a llvm::Function. Any parameter, return or function attributes are also added to the function. If a module is provided, the module if first checked to see if the function already exists. If it does, it is immediately returned. If the function doesn't exist in the module, its prototype is created and also inserted into the end of the modules function list. If no module is provided, the function is left detached and must be added to a valid Module to be callable.

Warning
  If a module is not provided, the caller takes ownership of the returned function and is responsible for deallocating it.

Note
  The body of the function is left to derived classes to implement. As you need a Module to generate the prototype/body, this function serves two purposes. The first is to return the detached function signature if only a context is provided. The second is to ensure the function prototype and body (if required) is inserted into the module prior to returning.
  It is possible to end up with function symbol collisions if you do not have unique function symbols in your module

Parameters

  C | The LLVM Context
  M | The Module to write the function to

Reimplemented in IRFunctionBase.

## create() [2/2]

llvm::Function * create | ( | llvm::Module & | M | ) | const

inline inherited

Convenience method which always uses the provided module to find the function or insert it if necessary.

Parameters

  M | The llvm::Module to use

## dependencies()

const std::vector< const char * > & dependencies | ( |  | ) | const

inline inherited

## fold()

template<typename SignatureT>

llvm::Value * fold | ( | const std::vector< llvm::Value * > & | args,
|  | llvm::LLVMContext & | C ) const

inline final override virtual inherited

Reimplemented from CFunctionBase.

## get()

llvm::Function * get | ( | const llvm::Module & | M | ) | const

inherited

Convenience method for calling M.getFunction(symbol). Returns a nullptr if the function has not yet been created or if it is embedded IR.

Parameters

  M | The llvm::Module to use

## hasConstantFold()

bool hasConstantFold | ( |  | ) | const

inline inherited

## hasParamAttribute()

bool hasParamAttribute | ( | const size_t | i,
|  | const llvm::Attribute::AttrKind & | kind ) const

inline inherited

Builder methods.

## match()

Function::SignatureMatch match | ( | const std::vector< llvm::Type * > & | args,
|  | llvm::LLVMContext & | C ) const

inline override virtual inherited

Override of match which inserts the SRET type such that the base class methods ignore it.

Reimplemented from Function.

## print()

void print | ( | llvm::LLVMContext & | C,
|  | std::ostream & | os,
|  | const char * | name = nullptr,
|  | const bool | axTypes = true ) const

inline override virtual inherited

Override of print to avoid printing out the SRET type.

Reimplemented from Function.

## setArgumentNames()

void setArgumentNames | ( | std::vector< const char * > | names | ) |

inline inherited

## setConstantFold()

void setConstantFold | ( | bool | on | ) |

inline inherited

## setDependencies()

void setDependencies | ( | std::vector< const char * > | deps | ) |

inline inherited

## setFnAttributes()

void setFnAttributes | ( | const std::vector< llvm::Attribute::AttrKind > & | in | ) |

inline inherited

## setParamAttributes()

void setParamAttributes | ( | const size_t | i,
|  | const std::vector< llvm::Attribute::AttrKind > & | in )

inline inherited

## setRetAttributes()

void setRetAttributes | ( | const std::vector< llvm::Attribute::AttrKind > & | in | ) |

inline inherited

## size()

size_t size | ( |  | ) | const

inline inherited

The number of arguments that this function has.

## symbol()

const char * symbol | ( |  | ) | const

inline inherited

The function symbol name.

This will be used as its identifier in IR and must be unique.

## types()

template<typename SignatureT>

llvm::Type * types | ( | std::vector< llvm::Type * > & | ,
|  | llvm::LLVMContext & | ) const

inline override virtual inherited

Populate a vector of llvm::Types which describe this function signature. This method is used by Function::create, Function::print and Function::match.

Implements Function.